import java.lang.*;
import java.util.*;

class PromoFive extends Promotion{

    PromoFive() {
        this.initialize();
    }

    private void initialize() {
        this.name("5 tapes for 5 days for $5.00 ");
        this.description("If the customer rents" +
              " 5 tapes at the same time the charge will" +
              " be $5.00 and the tapes will be due back" +
              " in 5 calendar days");
        this.id("a");
        this.active(true);
    }

    public double promoPrice(Customer aCustomer) {

        int weekday = Calendar.getInstance().get(Calendar.DAY_OF_WEEK);
        if (weekday != 5){ // 1 is Sun, 2 is Mon, 3 is .........
        System.out.println("result from thursday = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }
        // see if this promo applies

        // first check if two tapes are being purchased
        // here we do not care if they are any category
        // but we could check ..

        if (aCustomer.basket().tapes().size() < 3){
        System.out.println("result from thursday = " + Double.POSITIVE_INFINITY);
            return Double.POSITIVE_INFINITY;
        }
        // find the cheapest tape and give it free
        Tape cheapest = aCustomer.basket().leastExpensive();
        double result = aCustomer.basket().regularCost()
                                       - cheapest.rentalPrice();

        System.out.println("result from thursday = " + result);
        return result;
    }

    public boolean applicable(Customer aCustomer) {
        return true;
    }

}
